<template>
    <div>
        <search-input v-model="search" />

        <b-overlay :show="showOverlay" rounded="sm">
            <div v-if="displayResult">
                <phone-number-result-statistics
                    :description="statisticsDescription"
                    :successful="statSuccesful"
                    :corrected="statCorrected"
                    :failure="statFailure"
                    show-all-results
                ></phone-number-result-statistics>
                <phone-number-result-displayer
                    :no-items-text="displayerNoItemsText"
                    :successful-items="succesfulItems"
                    :corrected-items="correctedItems"
                    :failure-items="failureItems"
                ></phone-number-result-displayer>
            </div>
            <div v-else-if="displayError">
                <b-alert variant="danger" show>
                    <b-icon-x-circle-fill></b-icon-x-circle-fill>
                    &nbsp;
                    {{errorMessage}}
                </b-alert>
            </div>
            <div v-else>
                <p>Loading data from server...</p>
            </div>
        </b-overlay>
    </div>
</template>

<script>
import _ from "lodash";
import PhoneNumberService from "../services/phone-number-service";
import { VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED } from "../configs/config";
import { EventBus } from "../plugins/global-event-bus";

import SearchInput from "./SearchInput";
import PhoneNumberResultDisplayer from "./PhoneNumberResultDisplayer.vue";
import PhoneNumberResultStatistics from "./PhoneNumberResultStatistics.vue";

export default {
    name: "PageMain",
    components: {
        SearchInput,
        PhoneNumberResultDisplayer,
        PhoneNumberResultStatistics,
    },
    data() {
        return {
            search: "",
            showOverlay: false,
            file: null,
            displayResult: false,
            displayError: false,
            errorMessage: null,
            statSuccesful: 0,
            statCorrected: 0,
            statFailure: 0,
            resultItems: null,
        };
    },
    computed: {
        statisticsDescription() {
            if (this.search) {
                return "Test found on server that matches your filter: ";
            }
            return "Test found on server:";
        },
        succesfulItems() {
            if (this.resultItems instanceof Array) {
                return _.filter(this.resultItems, {
                    isValid: true,
                    isCorrected: false,
                });
            }
            return [];
        },
        correctedItems() {
            if (this.resultItems instanceof Array) {
                return _.filter(this.resultItems, {
                    isValid: true,
                    isCorrected: true,
                });
            }
            return [];
        },
        failureItems() {
            if (this.resultItems instanceof Array) {
                return _.filter(this.resultItems, { isValid: false });
            }
            return [];
        },
        displayerNoItemsText() {
            if (this.search) {
                return "No items found that match your search";
            }
            return "There are no items to show";
        },
    },
    methods: {
        _findItems() {
            PhoneNumberService.find(this.search)
                .then((result) => {
                    this._setResult(result.stats, result.items);
                })
                .catch((err) => {
                    this._setError(err);
                })
                .finally(() => {
                    this.showOverlay = false;
                });
        },
        _setResult(stats, items) {
            this.statSuccesful = stats.successful || 0;
            this.statCorrected = stats.corrected || 0;
            this.statFailure = stats.failure || 0;

            this.resultItems = items;

            this.errorMessage = null;
            this.displayError = false;
            this.displayResult = true;
        },
        _setError(err) {
            this.displayResult = false;
            this.errorMessage = err.message;
            this.displayError = true;
        },
        _onPhoneListUpdated() {
            this._findItems();
        },
    },
    watch: {
        search() {
            this._findItems();
        },
    },
    mounted() {
        this._findItems();

        EventBus.$on(
            VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED,
            this._onPhoneListUpdated
        );
    },
    destroyed() {
        EventBus.$off(
            VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED,
            this._onPhoneListUpdated
        );
    }
};
</script>
